program textobilet;

{
    Tests
    Copyright (C) 2009-2021  Artyomov Alexander and authors of content listed below

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
}

(* (a) Sergey V Kopylov, Alexander N Artyomov (c), (cl) 2009.
   License: GNU GPL. All rights reserved.
   Version: 0.1 (initial) *)

(* (a) Sergey V Kopylov, Alexander N Artyomov, Stanislav A Kozlovsky (c), (cl) 2010.
   License: GNU GPLv3. All rights reserved.
   Version: 0.2 *)

(* (a) Sergey V Kopylov, Alexander N Artyomov (c), (cl) 2010.
   License: GNU GPLv3. All rights reserved.
   Version: 0.3 *)

(* (a) Sergey V Kopylov, Alexander N Artyomov, Stanislav A Kozlovsky (c), (cl) 2010.
   License: GNU GPLv3. All rights reserved.
   Version: 0.4 *)

(* (a) Sergey V Kopylov, Alexander N Artyomov, Stanislav A Kozlovsky (c), (cl) 2010.
   License: GNU GPLv3. All rights reserved.
   Version: 0.5 *)

(* (a) Sergey V Kopylov, Alexander N Artyomov, Stanislav A Kozlovsky (c), (cl) 2019.
   License: GNU AGPLv3. All rights reserved.
   Version: 0.6 *)

{$MODE OBJFPC}    // Режим FreePascal    с объектами
{$LONGSTRINGS ON} // Включаем поддержку длинных строк
{$RANGECHECKS ON} // Включаем проверку диапазонов
{$SMARTLINK ON}   // Включаем "умную" линковку
{$INLINE ON}      // Включаем inline функции
//{$CODEPAGE UTF8}
//{$ModeSwitch UnicodeStrings}

uses SysUtils, Classes, Unix;

type

     subjs = 1..15; // тем
     anss  = 1..4;  // вариантов ответа
     trs   = 1..3;  // сложность
     aanss = array[anss] of widestring; // Массив для вариантов ответа
     aoL   = array of LongInt; // Для разных применений

     TQuest = class(TObject)  // Вопрос
        tr  : trs;    // Сложность
        subj: subjs;  // Тема
        q   : widestring; // Текст вопроса
        a   : aanss;  // Варианты ответа
        tru : anss;   // Верный ответ
        sol : widestring; // Решение
     public
     function OutTeXforPB(num : LongInt) : widestring; // Вывод вопросов банка для его печати
     function OutTeXstr(num : LongInt) : widestring; // Вывод вопросов в билет в формате TeX
     function OutTeXans(num : LongInt) : widestring; // Вывод ответов в таблицу в формате TeX 
     procedure RotateA(i : DWord); // Выбор порядка вариантов ответа
     procedure RandomA; // Случайное изменение порядка вариантов ответа

     end;

     variants  = 0..1; // число вариантов (билетов) в пакете

const
     subjsnames : array[subjs] of widestring =
     ('М1','М2','М3','М4','Т1','Т2','Т3','Т4','Э1','Э2','Э3','Э4','К','О','Я');

     lots : array[subjs] of LongInt = (1,1,1,1,1,1,1,1,1,1,1,1,1,1,1); // количество задач в пакете на соответствующую тему
     variants_count = High(variants); // число вариантов (билетов) в пакете
     packetcnt = 120; // число пакетов


type
     TDigest = class(TObject) // Потемная выборка индексов массива вопросов
     fsubj : subjs; // храним тему
     a : aoL;       // массив для выборки индексов из массива вопросов
     public
     constructor Create(subj : subjs);
     procedure Load;
     procedure Shift; // сдвинуть вопросы в теме
     end;

     TDigests = class(TObject)
     a : array[subjs] of TDigest;
     b : array[variants] of aoL; // Массив индексов вопросов для вариантов
     packetcnt : LongInt;
     public
     constructor Create;
     procedure Shift; // сдвинуть вопросы в темах
     procedure Loadb; // загрузить массив вопросов для вариантов
     procedure SavePacket(fn : utf8string);
     end;

  var
      qa : array of TQuest; // Динамический массив вопросов
      anssnf : DWord; // факториал комбинаций вариантов ответа

procedure RCleanStr(var s : widestring); var f : LongInt;
begin for f := Length(s) downto 1 do if s[f] > #32 then begin SetLength(s, f); Exit; end; s := ''; end;
procedure LCleanStr(var s : widestring); var f, l : LongInt;
begin l := Length(s); for f := 1 to l do if s[f] > #32 then begin s := Copy(s, f, l - f + 1); Exit; end;  s := ''; end;
procedure NeatStr(var s : widestring); // очистка строки
begin RCleanStr(s); LCleanStr(s); end;
function NeFact(n : LongInt) : QWord; var f : LongInt; begin NeFact := 1; for f := 1 to n do NeFact := NeFact * f; end;

procedure RandomAoL(var a : aoL);
  var
      f, r : LongInt;
      b     : aoL;
begin

while true do begin
r := Random(Length(a)); // получили случайное число
// добавили во временный массив случайный элемент из a
SetLength(b, Length(b) + 1); b[High(b)] := a[r];

for f := r to High(a) - 1 do begin
a[f] := a[f+1];
end;
SetLength(a, Length(a) - 1);

if Length(a) < 1 then break;
end;

a := b;

end;

function LoadFromFile(fn : widestring) : boolean; // Загрузка массива вопросов из файла банка вопросов
  var
          fp : Text;
           s : utf8string;
       state : LongInt = 0; // Состояние обработки
           q : TQuest;      // Временная переменная
           p : LongInt = 0; // Хранит позицию подстроки в строке
        lcnt : LongInt = 0; // Счётчик строк "банка"
        acnt : LongInt = 0; // Счётчик ответов
        stmp : widestring;      // Временная строка
               procedure addtoarray;
                 var
                     f : LongInt;
               begin
                    // очищаем строки от пустот по краям
                    NeatStr(q.q); NeatStr(q.sol); for f := 1 to High(q.a) do NeatStr(q.a[f]);
                    // увеличиваем размер массива и присваиваем временную переменную
                    SetLength(qa, Length(qa) + 1); qa[High(qa)] := TQuest.Create; qa[High(qa)] := q;
                    // сбрасываем строковые значения на пустые, создавая новый объект
                    q := TQuest.Create; // создаём новенький класс с тем же указателем - старый ушёл в массив
               end;
begin

q := TQuest.Create;

Assign(fp, fn);
WriteLn(stderr, 'Подготавливаем файл банка заданий к чтению...'); WriteLn(stderr);
ReSet(fp);
while not eof(fp) do begin
ReadLn(fp, s); inc(lcnt); // Читаем строку и считаем её

case state of
0: begin // Пока нет никаких секций (до вопросов) - ждём их
   p := Pos('\section{', s);
   if p > 0 then begin
      WriteLn(stderr, 'На ', lcnt, ' строке найдена \section{ ...');
      q.subj := StrToIntDef(Copy(s, p + 9, Pos('}', s) - (p + 9)), 0); // Если ошибка набора - сработает rangechecks
      WriteLn(stderr, '  Ok, Тема = ', q.subj); WriteLn(stderr);
      state := 1;
   end; {end if}
end;
1: begin // Аккумулируем текст задания и ждём субсекцию
   p := Pos('\subsection{', s);
   if p > 0 then begin
      WriteLn(stderr, 'На ', lcnt, ' строке найдена \subsection{ ...');
      inc(acnt);

      stmp := Copy(s, p + 12, Pos('}', s) - (p + 12));

      case acnt of
      1..High(anss): begin
                     if stmp  = '+' then begin q.tru := acnt; WriteLn(stderr, '  Вариант ', q.tru, ' установлен как верный'); end;
      end;
      else
        WriteLn(stderr, '  Устанавливаем сложность ...');
        q.tr := StrToIntDef(stmp, 0); // Если ошибка набора - сработает rangechecks
        WriteLn(stderr, '  Ok. Сложность ', q.tr);
        state := 2;
        acnt := 0;
      end; {end select}
   end else begin
                   // попутно накапливаем текст вопрсов
                   if acnt = 0 then q.q := q.q + #10 + s else q.a[acnt] := q.a[acnt] + #10 + s; 
   end; {end if}
end;
2: begin // Ждём новую секцию, а пока накапливаем решение
   p := Pos('\section{', s);
   if p > 0 then begin
        AddToArray;
      WriteLn(stderr, 'На ', lcnt, ' строке найдена \section{ ...');
      q.subj := StrToIntDef(Copy(s, p + 9, Pos('}', s) - (p + 9)), 0); // Если ошибка набора - сработает rangechecks
      WriteLn(stderr, '  Ok, Тема = ', q.subj); WriteLn(stderr);
      state := 1;
   end else begin
      q.sol := q.sol + #10 + s; // накапливаем решение
   end; {end if}
end;


end; {end select}

end; {wend}
Close(fp);

// если "банк" закончился, а состояние чтения решения - иначе ошибка структуры "банка"
if state = 2 then AddToArray else WriteLn(stderr, 'Ошибка структуры в последнем вопросе.'); 
Exit(false); // Ok. Ob.
end;

// "Перемешать" варианты ответов во всём массиве
procedure RandomVariants; var  f : LongInt; begin for f := 0 to High(qa) do qa[f].RandomA; end;

function TQuest.OutTeXforPB(num : LongInt) : widestring;
  var
      f   : LongInt;
      tmp : widestring = '';
begin

for f := 1 to High(a) do if f <> tru then
    tmp := tmp + '\hspace{4pt}' + Char(LongInt(Char('A')) + f - 1) + ')\hspace{1pt}' + a[f] + ' '
    else tmp := tmp + '\hspace{4pt}\textbf{' + Char(LongInt(Char('A')) + f - 1) + ')}{$\bigstar$}\hspace{1pt}' + a[f] + ' ';

Exit('\textbf{' + IntToStr(num) + '.} ' + #10 + 'Раздел: ' + subjsnames[subj] + ', Сложность: ' + IntToStr(tr) + #10#10 + q + #10#10 +
'\textbf{Варианты ответов:} ' + #10 +
tmp + #10#10 + '\textbf{Решение:} ' + sol + #10#10 + '\smallskip \hrule \smallskip'  + #10#10#10);

end;
function TQuest.OutTeXstr(num : LongInt) : widestring;
  var
      f   : LongInt;
      tmp : widestring = '';
begin

for f := 1 to High(a) do tmp := tmp + '\hspace{4pt}\textbf{' + Char(LongInt(Char('A')) + f - 1) + ')}\hspace{1pt}' + a[f] + ' ';

OutTeXstr := '\textbf{' + IntToStr(num) + '.} ' + #10 + q + #10#10 +
'\textbf{Варианты ответов:} ' + #10 +
tmp + #10#10 + '\smallskip \hrule \smallskip' + #10#10#10;

end;
function TQuest.OutTeXans(num : LongInt) : widestring;
  var
      f   : LongInt;
      tmp : widestring = '';
begin

// \put(0.7,6.56){2.}\put(2.06,6.56){A}\put(2.94,6.56){B}\put(3.82,6.56){C}\put(4.70,6.56){D}
// \put(0.7,7.06){1.}\put(2.06,7.06){A}\put(2.94,7.06){B}\put(3.82,7.06){C}\put(4.70,7.06){D}\put(5.46,6.56){\small{Э:2}}

for f := 1 to High(a) do
  if tru = f then tmp := tmp + '\put(' + FloatToStr(2.06 + ((f-1)*0.88)) + ',' + FloatToStr(7.3-(num-1)*0.5133) + '){$\bigstar$}'
   else tmp := tmp + '\put('  + FloatToStr(2.06 + ((f-1)*0.88)) + ',' +  FloatToStr(7.26-(num-1)*0.5133) + '){' + Char(LongInt(Char('A')) + f - 1) + '}';

OutTeXans := '\put(0.7,' +  FloatToStr(7.26 - (num - 1)*0.5133) + '){' + IntToStr(num) + '.}' + '\put(5.46,' +
              FloatToStr(7.26-(num-1)*0.5133) + '){\small{' + subjsnames[subj] + '}}' + tmp;

end;

procedure TQuest.RotateA(i : DWord);
  var
      ls, cnt  : LongInt;
      bs : boolean = false;

procedure rc(l : LongInt); inline; register;
  var
      f, off : LongInt;
      c      : widestring;
begin if bs then Exit;

off := ls - l + 1;

if l > 2 then rc(l - 1);

for f := off + 1 to ls do begin

c := a[off];
a[off] := a[f];
a[f] := c;

// Вместе с репозицией правильного варианта меняем правильный ответ.
if f = tru then tru := off else if off = tru then tru := f;
// Завершаем выполнение, если i исчерпано
dec(cnt); if cnt < 1 then begin ls := 0; bs := true; Exit; end;

if l > 2 then rc(l - 1);

end; {next f}

end;

begin
  ls := Length(a); cnt := i;
  if i <> anssnf then rc(ls);
end; // End RotateA
procedure TQuest.RandomA; begin RotateA(Random(anssnf)); end;

constructor TDigest.Create(subj : subjs);
begin
inherited Create;
fsubj := subj;
Load;
end;

procedure TDigest.Load;
  var f : LongInt;
begin
for f := 0 to High(qa) do
if qa[f].subj = fsubj then begin
SetLength(a, Length(a) + 1);
a[High(a)] := f;
end;

if Length(a) < lots[fsubj] * (variants_count + 1) then begin
WriteLn(stderr, 'Ошибка ! Задач по теме №', fsubj,
' ("', subjsnames[fsubj], '") в банке меньше (', Length(a),') числа требуемых - ', lots[fsubj] * (variants_count + 1));
HALT(1); end;
end;

procedure TDigest.Shift;
{  var f : LongInt; tmp : LongInt;}
begin
//  перемещение по банку и между вариантами остановлено
//  tmp := a[Low(a)];
//  for f := Low(a) to High(a) - 1 do begin
//  a[f] := a[f+1];
//  end;
//  a[High(a)] := tmp;
end;
procedure TDigests.Shift; {var f : LongInt;} begin {for f := Low(a) to High(a) do a[f].Shift;} end;

constructor TDigests.Create;
  var f : LongInt;
begin
// inherited Create;
for f := Low(a) to High(a) do a[f] := TDigest.Create(f);
end;

procedure TDigests.Loadb;
  var f, ff, fff : LongInt;
begin
for f := Low(b) to High(b) do SetLength(b[f], 0);

for f := Low(b) to High(b) do begin
for ff := Low(a) to High(a) do begin
for fff := 1 to lots[ff] do begin

SetLength(b[f], Length(b[f]) + 1);

b[f][High(b[f])] := a[ff].a[fff+(f*lots[ff])-1];

end;
end;
end;

for f := Low(b) to High(b) do RandomAoL(b[f]);
end;

procedure TDigests.SavePacket(fn : utf8string);
  var     fp : Text; f, ff : LongInt;
          YY,MM,DD : Word;
begin
inc(packetcnt);
Loadb;
RandomVariants; // делаем случайной комбинацию вариантов ответа везде
DeCodeDate (Date,YY,MM,DD); // Получаем текущую дату
YY := 2013;
Assign(fp, fn);
ReWrite(fp);

WriteLn(fp, '\documentclass[12pt]{article}');
WriteLn(fp, '\usepackage{mathtext}');
WriteLn(fp, '\usepackage{graphicx}');
WriteLn(fp, '\usepackage[T2A]{fontenc}');
WriteLn(fp, '\usepackage[utf8x]{inputenc}');
WriteLn(fp, '\usepackage[english,russian]{babel}');
WriteLn(fp, '\usepackage{amsmath,amstext,amssymb,array,textcomp}');
WriteLn(fp, '\usepackage[papersize={210mm,297mm},left=1cm,right=1cm,top=1cm,bottom=1cm,bindingoffset=0cm]{geometry}');
WriteLn(fp, '\pagestyle{empty} % Убираем нумерацию страниц');
WriteLn(fp, '\parindent=0pt % Выключам абзацный отступ');
WriteLn(fp, '');

WriteLn(fp, '\DeclareFontShape{OT1}{cmr}{m}{n}%');
WriteLn(fp, '{<5><6><7><8><9><10><12>gen*cmr%');
WriteLn(fp, '<10.95>cmr10%');
WriteLn(fp, '<14.4>cmr12%');
WriteLn(fp, '<17.28><20.74><24.88>cmr17');
WriteLn(fp, '<72>cmr17}{}');
WriteLn(fp, '');
WriteLn(fp, '\renewcommand\normalsize{\fontsize{14}{16.8pt}\selectfont}');

WriteLn(fp, '');
WriteLn(fp, '\begin{document}');

for f := Low(b) to High(b) do begin // вариант



if f > Low(b) then WriteLn(fp, '\newpage');

WriteLn(fp, '\bfseries');
WriteLn(fp, '\begin{small}');
WriteLn(fp, '\begin{center}Министерство образования и науки Российской Федерации\\');
WriteLn(fp, 'Государственное образовательное учреждение\\');
WriteLn(fp, 'Высшего профессионального образования\\');
WriteLn(fp, '«МОСКОВСКИЙ ГОСУДАРСТВЕННЫЙ ОТКРЫТЫЙ УНИВЕРСИТЕТ»\end{center}');
WriteLn(fp, '');
WriteLn(fp, '\vspace{-20pt}');
WriteLn(fp, '');
WriteLn(fp, '\smallskip');
WriteLn(fp, '');
WriteLn(fp, '\begin{flushright}');
WriteLn(fp, '\begin{minipage}[b]{0.40\linewidth}');
WriteLn(fp, '\begin{center}');
WriteLn(fp, '\normalsize{Утверждаю}');
WriteLn(fp, '\end{center}');
WriteLn(fp, '\vspace{-25pt}');
WriteLn(fp, '\begin{flushright}');
WriteLn(fp, 'Первый проректор по учебной работе');
WriteLn(fp, '\newline\newline');
WriteLn(fp, '\underline{\hspace{138pt}}Е.Н.~Щербак\\');
WriteLn(fp, format('«\underline{\hspace{30pt}}»\underline{\hspace{100pt}} %d г.', [YY]));
WriteLn(fp, '\end{flushright}');
WriteLn(fp, '\end{minipage}');
WriteLn(fp, '\end{flushright}');
WriteLn(fp, '');
WriteLn(fp, '\vspace{-53pt}');
WriteLn(fp, '\begin{flushleft}');
WriteLn(fp, '\begin{minipage}[b]{0.39\linewidth}');
WriteLn(fp, '\vspace{-25pt}');
WriteLn(fp, '\begin{flushright}');
WriteLn(fp, 'Председатель предметной комиссии');
WriteLn(fp, '\newline\newline');
WriteLn(fp, '\underline{\hspace{127pt}}С.В.~Копылов\\');
WriteLn(fp, format('«\underline{\hspace{30pt}}»\underline{\hspace{100pt}} %d г.', [YY]));
WriteLn(fp, '\end{flushright}');
WriteLn(fp, '\end{minipage}');
WriteLn(fp, '\end{flushleft}');
WriteLn(fp, '');
WriteLn(fp, '\begin{center}Экзаменационный тест №', packetcnt, '\\');
WriteLn(fp, 'для проведения вступительного испытания по предмету «Физика»\\');
WriteLn(fp, 'Вариант №', f + 1, '.\end{center}');
WriteLn(fp, '\end{small}');
WriteLn(fp, '\normalfont');
WriteLn(fp, '');
WriteLn(fp, '\vspace{-10pt}');
WriteLn(fp, '');
WriteLn(fp, '\hrule \smallskip');
WriteLn(fp, '');

for ff := Low(b[f]) to High(b[f]) do begin
WriteLn(fp, qa[b[f][ff]].OutTeXstr(ff+1));
if ff = 6 then begin
 WriteLn(fp, '{\footnotesize На второй странице вопросы с ', ff + 2, ' по ', High(b[f]) + 1, '$\curvearrowright$} \newpage');
 WriteLn(fp, '');
 WriteLn(fp, '\begin{center}\begin{small}\textbf{Экзаменационный тест №', packetcnt, ' по предмету «Физика». Вариант №', f + 1, '.}\end{small}\end{center}');
 WriteLn(fp, '');
               end;
end;

WriteLn(fp, '\newpage');

WriteLn(fp, '');
WriteLn(fp, '№ ', f + 1, '-', packetcnt);
WriteLn(fp, '');
WriteLn(fp, '\vspace{-225pt}');
WriteLn(fp, '\setlength{\unitlength}{1cm}');
WriteLn(fp, '\begin{picture}(6,9)(0,17)');
WriteLn(fp, '\linethickness{0.075mm}');
WriteLn(fp, '\put(0,8.9){\line(1,0){6.34}}');
WriteLn(fp, '\multiput(0,0)(0,0.5133){16}{\line(1,0){6.34}}');
WriteLn(fp, '\multiput(0,0)(1.85,0){2}{\line(0,0){8.9}}');
WriteLn(fp, '\put(6.34,0){\line(0,0){8.9}}');
WriteLn(fp, '\multiput(2.68,0)(0.88,0){4}{\line(0,0){7.7}}');
WriteLn(fp, '\put(0.7,8.4){№}');
WriteLn(fp, '\put(2.9,8.4){Варианты}');
WriteLn(fp, '\put(3.2,7.8){ответов}');
WriteLn(fp, '\put(0.07,7,8){вопроса}');
WriteLn(fp, '');
WriteLn(fp, '');


for ff := Low(b[f]) to High(b[f]) do begin
     WriteLn(fp, qa[b[f][ff]].OutTeXans(ff+1));
end;
 
 
WriteLn(fp, '');
WriteLn(fp, '\end{picture}');
WriteLn(fp, '');
WriteLn(fp, '');


WriteLn(fp, '\newpage');
end;

WriteLn(fp, '\end{document}');
Close(fp);
Shift;
end;

procedure PrintBank(fn : utf8string);
  var     fp : Text; f : LongInt;
begin
Assign(fp, fn);
ReWrite(fp);

WriteLn(fp, '\documentclass[11pt]{article}');
WriteLn(fp, '\usepackage{mathtext}');
WriteLn(fp, '\usepackage[utf8x]{inputenc}');
WriteLn(fp, '\usepackage{graphicx}');
WriteLn(fp, '\usepackage[T2A]{fontenc}');
WriteLn(fp, '\usepackage[english,russian]{babel}');
WriteLn(fp, '\usepackage{amsmath,amstext,amssymb,array,textcomp}');
WriteLn(fp, '\usepackage[papersize={210mm,297mm},left=1cm,right=1cm,top=1cm,bottom=1cm,bindingoffset=0cm]{geometry}');
WriteLn(fp, '\pagestyle{empty} % Убираем нумерацию страниц');
WriteLn(fp, '\parindent=0pt % Выключам абзацный отступ');
WriteLn(fp, '');

WriteLn(fp, '\begin{document}');
WriteLn(fp, '');

for f := 0 to High(qa) do WriteLn(fp, qa[f].OutTeXforPB(f+1));

WriteLn(fp, '');
WriteLn(fp, '\end{document}');
Close(fp);
end;

  var
      f  : LongInt;
      ds : TDigests;
      s  : utf8string;
      texlog : Text;

begin
Randomize; // инициализируем генератор случайных чисел
anssnf := NeFact(High(anss)); // получаем n-факториал для комбинаций ответов

LoadFromFile('bank.tex');

if ParamStr(1) = '--print-bank' then begin
PrintBank('printbank.tex');
fpSystem('latex printbank.tex && dvipdf printbank.dvi');
HALT;
end;

RandomVariants;
RandomVariants;
RandomVariants;
RandomVariants;

ds := TDigests.Create;

// Output written on packet_1.dvi (9 pages, 16844 bytes).
for f := 1 to packetcnt do begin
  ds.SavePacket('packet_'+IntToStr(f)+'.tex');
  fpSystem('latex packet_'+IntToStr(f)+'.tex && dvipdf packet_'+IntToStr(f)+'.dvi');
  Assign(texlog, 'packet_'+IntToStr(f)+'.log'); ReSet(texlog); // проверяем число страниц в пакете
         while not eof(texlog) do begin
         ReadLn(texlog, s);
          if (Pos('Output written on', s) <> 0) then if (Pos('(6 pages,', s) = 0) then begin
          WriteLn(stderr, 'ОШИБКА! В пакете ', f, ' число страниц не равно 6');
          HALT;
          end;
         end;
         Close(texlog);
end;

  fpSystem('rm *.dvi *.aux *.log && rm -Rf packets_pdf && mkdir packets_pdf && mv packet_*.pdf '+
   'packets_pdf && rm -Rf packets_tex && mkdir packets_tex && mv packet_*.tex packets_tex');

WriteLn(stderr, 'УСПЕШНО завершено !');

end.